//==============================================================================================
//
//	Microdyne Libraries for the Object Windows Libraries
//	Version 1.00
//
//	EFRAME.H - Extended Frame Class
//	Copyright  1993 by Microdyne Development Technologies
//	All rights reserved.
//==============================================================================================

#ifndef _EFRAME_H
#define _EFRAME_H

#include <owl.h>
#include <wics.h>
#include <ibar.h>
#include <sbar.h>
#include <printer.h>

//------------------------------------------------------------------------------------------------
//	Extended Frame Class
//------------------------------------------------------------------------------------------------

_CLASSDEF(TExtendedMDIFrame)

class TExtendedMDIFrame : public TMDIFrame
{
private:
	PTIconBar		AnIconBar;
	PTStatusBar		AStatusBar;
	HBRUSH			hBackgroundBrush;
	PTPrinter		APrinter;

	virtual const Pchar streamableName() const { return "TExtendedMDIFrame"; }

protected:
	virtual LPSTR GetClassName() { return "EFRAME"; }
	virtual void GetWindowClass(WNDCLASS _FAR & AWndClass);
	virtual void WMSize(RTMessage Msg) = [WM_FIRST + WM_SIZE];
	virtual void WMCommDlgHelp (RTMessage);
	virtual void OpenFileHelp() {};
	virtual void SaveFileHelp() {};
	virtual void ChooseColorHelp() {};
	virtual void ChooseFontHelp() {};
    virtual void FindTextHelp() {};
	virtual void ReplaceTextHelp() {};
	virtual void PrintHelp() {};
    virtual void PrintSetupHelp() {};
	virtual void CMPrinterSetup (RTMessage) = [CM_FIRST + CM_PRINTERSETUP];

public :
	UINT			idHelpMessage;
	UINT			idFindTextMessage;

	TExtendedMDIFrame(LPSTR ATitle, LPSTR MenuName, BOOL fIconbar, BOOL fStatusbar, PTModule AModule = NULL);
	TExtendedMDIFrame(LPSTR ATitle, int MenuId, BOOL fIconbar, BOOL fStatusbar, PTModule AModule = NULL);
	virtual ~TExtendedMDIFrame();

	virtual void DefWndProc(RTMessage Msg);
	virtual PTPrinter GetPrinter() { return APrinter; }
	virtual void CheckMenu (UINT id);
	virtual void UncheckMenu (UINT id);
	virtual void FlipMenuCheck (UINT id);
	virtual void DisableMenuEntry (UINT id);
	virtual void EnableMenuEntry (UINT id);
	virtual PTIconBar GetIconBar() { return AnIconBar; }
	virtual PTStatusBar GetStatusBar() { return AStatusBar; }
	virtual void GetSelectedFontFamilyName (WORD cchMax, LPSTR lpFamilyName);
	virtual int	 GetSelectedFontSize ();
	virtual void InsertIconBarSpace();
	virtual BOOL IsIconBarButtonChecked (WORD Id);
	virtual void PlaceIconBarButton (WORD x, WORD y, WORD Id, BOOL fState = FALSE);
	virtual void PlaceIconBarButton (WORD Id, BOOL fState = FALSE);
	virtual void PlaceFontSelectionControl (WORD x, WORD y, WORD Id);
	virtual void PlaceFontSelectionControl (WORD Id);
	virtual void RemoveIconBarControl (WORD Id);
	virtual void SetIconBarButtonCommandCode (WORD Id, WORD cmd);
	virtual void SetIconBarButtonState (WORD Id, BOOL fState);
	virtual void SetFontFamilyName (LPSTR lpFamilyName);
	virtual void SetFontFamilyCommandCode (WORD code);
	virtual void SetFontSize (int s);
	virtual void SetFontSizeCommandCode (WORD code);
	virtual void SetFontStyle(LOGFONT FAR *lplf);
	virtual void SetIconBarStartPoint (WORD x);
};
#endif